diff -ur slackware64-current.2/source/d/rust/rust.SlackBuild slackware64-current.3/source/d/rust/rust.SlackBuild
--- slackware64-current.2/source/d/rust/rust.SlackBuild	2024-12-08 23:30:08.167236525 +0100
+++ slackware64-current.3/source/d/rust/rust.SlackBuild	2025-01-07 13:31:22.892614001 +0100
@@ -74,14 +74,18 @@
 fi
 
 # Fail on undeclared variables and broken pipes:
-set -u -o pipefail
+set -o pipefail
 
 # If the bootstrap binaries are present, use those. Otherwise bootstrap from
 # installed compiler.
-if /bin/ls *-unknown-linux-gnu.tar.?z 1> /dev/null 2> /dev/null ; then
+if /bin/ls *-unknown-linux-gnu*.tar.?z 1> /dev/null 2> /dev/null ; then
   LOCAL_BOOTSTRAP=no
 else
-  LOCAL_BOOTSTRAP=yes
+  if [ "$LOCAL_BOOTSTRAP" = "" ] && [ -x /usr/bin/cargo ] && [ -x /usr/bin/rustc ] ; then
+    LOCAL_BOOTSTRAP=yes
+  else
+    LOCAL_BOOTSTRAP=no
+  fi
 fi
 
 # https://forge.rust-lang.org/platform-support.html
@@ -97,6 +101,21 @@
 elif [ "$ARCH" = "armv7hl" ]; then
   BARCH="armv7"
   TARCH="$BARCH"
+elif [ "$ARCH" = "arm" ]; then
+  BARCH="armv5te"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc" ]; then
+  BARCH="powerpc"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc64" ]; then
+  BARCH="powerpc64"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "ppc64le" ]; then
+  BARCH="powerpc64le"
+  TARCH="$BARCH"
+elif [ "$ARCH" = "riscv64" ]; then
+  BARCH="riscv64gc"
+  TARCH="$BARCH"
 else
   BARCH="$ARCH"
   TARCH="$ARCH"
@@ -105,6 +124,10 @@
 # Bootstrapping ABI:
 if [ "$ARCH" = "armv7hl" ]; then
   BABI="gnueabihf"
+elif [ "$ARCH" = "arm" ]; then
+  BABI="gnueabi"
+elif [ "$ARCH" = "mips64el" ]; then
+  BABI="gnuabi64"
 else
   BABI="gnu"
 fi
@@ -129,7 +149,8 @@
 
 # Not needed, as the build will automatically use as many jobs as there are
 # threads.
-#NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+JOBS=`echo $NUMJOBS  | sed 's/-j//'`
 
 if [ "$ARCH" = "i586" ]; then
   LIBDIRSUFFIX=""
@@ -144,15 +167,32 @@
 # Support libdir other than "lib":
 cat $CWD/141729.patch | patch -p1 --verbose || exit 1
 
+# Patch armv5te atomic operations (already defined in libgcc) and rls AtomicU64
+if [ "${ARCH}" = "arm" ]; then
+  (
+  cd vendor/compiler_builtins*
+  ckorig=`sha256sum src/arm_linux.rs | cut -f1 -d' '`
+  zcat $CWD/atomic_builtins_gcc9.diff.gz | patch -p3 --verbose || exit 1
+  cknew=`sha256sum src/arm_linux.rs | cut -f1 -d' '`
+  # Fix cargo checksum for above patch
+  sed -i "s/$ckorig/$cknew/" .cargo-checksum.json
+  ) || exit 1
+fi
+
+# rust-lld was enabled by default in 1.88 even when using external llvm.
+# Reverting behaviour:
+# https://github.com/rust-lang/rust/pull/143255
+zcat $CWD/disable_rust-lld_by_default.diff.gz | patch -p1 --verbose || exit 1
+
 if [ "$LOCAL_BOOTSTRAP" != "yes" ] ; then
   # rust requires bootstrapping with the previous rust version.
   # versions are defined in src/stage0.txt.
   mkdir -p build/cache/$RSTAGE0_DIR
-  cp $CWD/$PKGNAM-std-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z \
-     $CWD/$SRCNAM-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z \
+  cp $CWD/$PKGNAM-std-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z \
+     $CWD/$SRCNAM-$RSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z \
      build/cache/$RSTAGE0_DIR
   mkdir -p build/cache/$CSTAGE0_DIR
-  cp $CWD/cargo-$CSTAGE0_VERSION-$BARCH-unknown-linux-gnu.tar.?z build/cache/$CSTAGE0_DIR
+  cp $CWD/cargo-$CSTAGE0_VERSION-$BARCH-unknown-linux-gnu*.tar.?z build/cache/$CSTAGE0_DIR
 fi
 
 # Build configuration:
@@ -192,7 +212,6 @@
 profile = "dist"
 
 [llvm]
-ccache = "/usr/bin/ccache"
 link-shared = true
 download-ci-llvm = false
 
@@ -208,6 +229,7 @@
 # Do not query new versions of dependencies online.
 locked-deps = true
 $BUILDDOCS_OPTION
+jobs = $JOBS
 
 [install]
 prefix = "/usr"
@@ -201,8 +236,45 @@
 [target.x86_64-unknown-linux-gnu]
 llvm-config = "/usr/bin/llvm-config"
 
+[target.arm-unknown-linux-gnueabi]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.armv5te-unknown-linux-gnueabi]
+llvm-config = "/usr/bin/llvm-config"
+
 [target.armv7-unknown-linux-gnueabihf]
 llvm-config = "/usr/bin/llvm-config"
+
+[target.aarch64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.powerpc64le-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mips-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mipsel-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.mips64el-unknown-linux-gnuabi64]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.riscv64gc-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.s390x-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
+[target.loongarch64-unknown-linux-gnu]
+llvm-config = "/usr/bin/llvm-config"
+
 EOF
 fi
 
@@ -236,6 +308,12 @@
   fi
 fi
 
+# On mips[el] from rust 1.74, the error "Undefined temporary symbol $BB217_1" will raise by newer rust. 
+# Adding "-C opt-level=1" is a workaround
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ]; then
+  export RUSTFLAGS="$RUSTFLAGS -C opt-level=1"
+fi
+
 # Fix path to the rust libraries in rust-analyzer:
 if [ -r src/tools/rust-analyzer/crates/rust-analyzer/src/config.rs ]; then
   if [ ! "$LIBDIRSUFFIX" = "" ]; then
@@ -283,7 +361,7 @@
 
 # Evidently there are a lot of duplicated libraries in this tree, so let's
 # try to save some space:
-( cd $PKG/usr/lib${LIBDIRSUFFIX}/rustlib/*-linux-gnu/lib && for file in *.so ; do if cmp -s $file ../../../$file ; then ln -sf ../../../$file .; fi; done )
+( cd $PKG/usr/lib${LIBDIRSUFFIX}/rustlib/*-linux-gnu*/lib && for file in *.so ; do if cmp -s $file ../../../$file ; then ln -sf ../../../$file .; fi; done )
 
 # Strip ELF objects:
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
diff -ur slackware64-current.2/source/d/rust-bindgen/rust-bindgen.SlackBuild slackware64-current.3/source/d/rust-bindgen/rust-bindgen.SlackBuild
--- slackware64-current.2/source/d/rust-bindgen/rust-bindgen.SlackBuild	2021-09-09 19:19:52.527012986 +0200
+++ slackware64-current.3/source/d/rust-bindgen/rust-bindgen.SlackBuild	2021-09-18 13:42:54.186961238 +0200
@@ -98,6 +98,37 @@
 directory = "vendor"
 EOF
 
+# rustix uses now by default linux_raw backend for syscalls, but seems supported only
+# for aarch64, arm, mipsel, mips64el, powerpc64le, riscv64, x86, and x86_64.
+# Re-add real errno for other architectures, or you can pass "--cfg=rustix_use_libc" 
+# to force libc usage.
+case "$ARCH" in
+  mips|ppc|ppc64|s390x|loongarch64) 
+    (cd vendor
+     rm -rf errno
+     tar xvf $CWD/errno-*.tar.lz
+     for r in rustix*
+     do
+       (cd $r
+       perl -n -e '
+	 if(m/dependencies.libc_errno/) { $status=1; }
+	 if($status && m/"0.3.[012]"/) {
+	   s/"0.3.[012]"/"0.3.3"/;
+	   $status=0;
+	 }
+	 print;
+       ' Cargo.toml > Cargo.toml.tmp
+       \mv Cargo.toml.tmp Cargo.toml
+       cat .cargo-checksum.json  | perl -e '($newck)=split(" ",$ARGV[0]);while(<STDIN>) { s/("Cargo.toml":)"(\S+?)"/$1"$newck"/; print;}' `sha256sum Cargo.toml` > .cargo-checksum.json.tmp
+       \mv .cargo-checksum.json.tmp .cargo-checksum.json
+       )
+     done
+    )
+    #SLKRUSTFLAGS="--cfg=rustix_use_libc"
+    ;;
+esac
+
+RUSTFLAGS="$SLKRUSTFLAGS" \
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
 RUSTONIG_DYNAMIC_LIBONIG=1 \
@@ -104,13 +104,12 @@
 cargo build \
   --offline \
   --release \
-  --target $ARCH-unknown-linux-gnu \
   --verbose \
   $NUMJOBS || exit 1
 
 mkdir -p $PKG/usr/bin
-install -m 755 target/$ARCH-unknown-linux-gnu/release/bindgen \
-  $PKG/usr/bin/
+install -m 755 target/release/bindgen \
+  $PKG/usr/bin/ || exit 1
 
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
   | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
diff -ur slackware64-current/source/d/slacktrack/slacktrack.SlackBuild slackware64-current.2/source/d/slacktrack/slacktrack.SlackBuild
--- slackware64-current/source/d/slacktrack/slacktrack.SlackBuild	2024-11-22 09:34:48.000000000 +0100
+++ slackware64-current.2/source/d/slacktrack/slacktrack.SlackBuild	2025-01-07 13:31:22.992619350 +0100
@@ -8,6 +8,7 @@
 PKGNAM=slacktrack
 export VERSION=2.24
 # Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
 case "$( uname -m )" in
   i?86)    export ARCH=i686
            PKGEXT=txz ;;
@@ -15,6 +16,7 @@
      *)    export ARCH=$( uname -m )
            PKGEXT=txz ;;
 esac
+fi
 BUILD=${BUILD:-1}
 export BUILD
 
@@ -34,5 +36,8 @@
 tar xvf $CWD/slacktrack-$VERSION-source.tar.xz
 cd slacktrack-project || exit 1
 
+# Fix incorrect ARCH assignment if already set
+zcat $CWD/fix_already_set_arch.patch.gz | patch -p1
+
 # Start the "real" SlackBuild:
 ./slacktrack.SlackBuild
diff -ur slackware64-current.2/source/d/vala/vala.SlackBuild slackware64-current.3/source/d/vala/vala.SlackBuild
--- slackware64-current.2/source/d/vala/vala.SlackBuild	2025-06-13 14:37:05.659192007 +0200
+++ slackware64-current.3/source/d/vala/vala.SlackBuild	2025-07-17 13:38:22.584141419 +0200
@@ -99,6 +99,13 @@
 fi
 
 make $NUMJOBS || make || exit 1
+
+# or1k not able to build devhelp from vala 0.56.18, put a placeholder to avoid installation errors
+if [ `ls doc/manual/devhelp/ | wc -l` -eq 0 ]
+then
+  echo "Unable to build devhelp" > doc/manual/devhelp/placeholder.txt
+fi
+
 make install DESTDIR=$PKG || exit 1
 
 # Don't ship .la files:
diff -ur slackware64-current/source/e/emacs/emacs.SlackBuild slackware64-current.2/source/e/emacs/emacs.SlackBuild
--- slackware64-current/source/e/emacs/emacs.SlackBuild	2024-07-21 04:37:31.065159446 +0200
+++ slackware64-current.2/source/e/emacs/emacs.SlackBuild	2025-01-07 13:31:23.262633792 +0100
@@ -115,6 +115,9 @@
 tar xvf $CWD/$SRCNAM-$TARBALLVER.tar.xz || exit 1
 cd $SRCNAM-$SRCDIRVER || exit 1
 
+# Fix incorrect SIGSTKSZ on or1k:
+zcat $CWD/sigstksz_or1k.diff.gz  | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/installer/build_installer.sh slackware64-current.3/source/installer/build_installer.sh
--- slackware64-current.2/source/installer/build_installer.sh	2024-09-12 22:19:54.662013459 +0200
+++ slackware64-current.3/source/installer/build_installer.sh	2024-09-13 13:44:37.107966821 +0200
@@ -97,7 +97,7 @@
     ADD_ALLMODS=0         # add all the kernel modules
     ADD_MANPAGES=1
     COMPRESS_MODS=0       # already compressed in a/kernel-modules.t?z package already
-    COMPRESSSUFFIX=".xz"  # if the modules are compressed already we might need this
+    #COMPRESSSUFFIX=".xz"  # if the modules are compressed already we might need this
     DISTRODIR=${DISTRODIR:-"slackware"} # below this you find a,ap,d,..,y
     LIBDIRSUFFIX=${LIBDIRSUFFIX:-""} # the default
     RECOMPILE=1           # recompile busybox/dropbear and add new binaries
@@ -152,10 +152,10 @@
     ADD_NETMODS=1         # add network modules
     ADD_PCMCIAMODS=1      # add pcmcia modules
     ADD_MANPAGES=1        # Add preprocessed manpages
-    DISTRODIR=${DISTRODIR:-"slackware"} # below this you find a,ap,d,..,y
+    #DISTRODIR=${DISTRODIR:-"slackware"} # below this you find a,ap,d,..,y
     COMPRESS_MODS=1       # compress kernel modules
     COMPRESSSUFFIX=""
-    LIBDIRSUFFIX=""       # the default
+    #LIBDIRSUFFIX=""       # the default
     RECOMPILE=0           # re-use binaries from existing initrd and packages
     SPLIT_INITRD=0        # Do not create separate initrd for each kernel
     USBBOOT=0             # do not build the USB boot image
diff -ur slackware64-current.2/source/installer/installer.SlackBuild slackware64-current.3/source/installer/installer.SlackBuild
--- slackware64-current.2/source/installer/installer.SlackBuild	2022-09-06 20:27:30.645132064 +0200
+++ slackware64-current.3/source/installer/installer.SlackBuild	2023-05-01 20:57:27.969137234 +0200
@@ -49,6 +49,10 @@
   export ARCH
 fi
 
+if [ -z "$OUTPUT" ]; then
+  OUTPUT=$TMP/installer
+fi
+
 NUMJOBS=${NUMJOBS:-" -j7 "}
 
 mkdir -p $OUTPUT
diff -ur slackware64-current.2/source/kde/kde/cmake/akonadi slackware64-current.3/source/kde/kde/cmake/akonadi
--- slackware64-current.2/source/kde/kde/cmake/akonadi	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/akonadi	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,28 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" -o "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "sparc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_EXE_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DLIBEXEC_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/digikam slackware64-current.3/source/kde/kde/cmake/digikam
--- slackware64-current.2/source/kde/kde/cmake/digikam	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/digikam	2021-09-18 13:42:54.216962753 +0200
@@ -1,3 +1,8 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+
 mkdir cmake-build
 cd cmake-build
   cmake \
@@ -17,6 +22,7 @@
     -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
     -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
     -DBUILD_TESTING=OFF \
+    $CMAKE_EXTRA \
     -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
     -DPYTHON_EXECUTABLE=/usr/bin/python3 \
     -DENABLE_KFILEMETADATASUPPORT=ON \
diff -ur slackware64-current.2/source/kde/kde/cmake/kdenetwork-filesharing slackware64-current.3/source/kde/kde/cmake/kdenetwork-filesharing
--- slackware64-current.2/source/kde/kde/cmake/kdenetwork-filesharing	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kdenetwork-filesharing	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,29 @@
+if [ "$ARCH" = "riscv64" ]
+then
+  CMAKE_EXTRA="-DCMAKE_MODULE_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    -DPYTHON_EXECUTABLE=/usr/bin/python3 \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/kmouth slackware64-current.3/source/kde/kde/cmake/kmouth
--- slackware64-current.2/source/kde/kde/cmake/kmouth	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kmouth	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,23 @@
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DKF_IGNORE_PLATFORM_CHECK=TRUE \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/krita slackware64-current.3/source/kde/kde/cmake/krita
--- slackware64-current.2/source/kde/kde/cmake/krita	2021-09-30 19:56:09.556980609 +0200
+++ slackware64-current.3/source/kde/kde/cmake/krita	2022-07-26 12:11:11.111111111 +0200
@@ -1,3 +1,12 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "riscv64" -o "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "sparc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+if [ "$ARCH" = "or1k" ]
+then
+  SLKCFLAGS="-O2 -mcmodel=large"
+fi
+
 mkdir cmake-build
 cd cmake-build
   cmake \
@@ -17,6 +22,7 @@
     -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
     -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
     -DBUILD_TESTING=OFF \
+    $CMAKE_EXTRA \
     -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
     -DPYTHON_EXECUTABLE=/usr/bin/python3 \
     -DBUILD_KRITA_QT_DESIGNER_PLUGINS=ON \
diff -ur slackware64-current.2/source/kde/kde/cmake/ktimer slackware64-current.3/source/kde/kde/cmake/ktimer
--- slackware64-current.2/source/kde/kde/cmake/ktimer	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/ktimer	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,23 @@
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DKF_IGNORE_PLATFORM_CHECK=TRUE \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/kwin slackware64-current.3/source/kde/kde/cmake/kwin
--- slackware64-current.2/source/kde/kde/cmake/kwin	2000-01-01 01:01:01.000000000 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kwin		2024-03-19 11:09:56.174717894 +0100
@@ -0,0 +1,29 @@
+if [ "$ARCH" = "or1k" ]
+then
+  SLKCFLAGS="-O2 -mcmodel=large"
+fi
+
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    -DPYTHON_EXECUTABLE=/usr/bin/python3 \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/syntax-highlighting slackware64-current.3/source/kde/kde/cmake/syntax-highlighting
--- slackware64-current.2/source/kde/kde/cmake/syntax-highlighting	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/syntax-highlighting	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,28 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" -o "$ARCH" = "or1k" -o "$ARCH" = "sh4" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DLIBEXEC_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/patch/extra-cmake-modules.patch.disabled slackware64-current.3/source/kde/kde/patch/extra-cmake-modules.patch.disabled
--- slackware64-current.2/source/kde/kde/patch/extra-cmake-modules.patch.disabled	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/patch/extra-cmake-modules.patch.disabled	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,2 @@
+# Fix incorrect generation for aarch64:
+cat $CWD/patch/extra-cmake-modules/sip_generator.patch | patch -p1 --verbose || { touch ${SLACK_KDE_BUILD_DIR}/${PKGNAME}.failed ; continue ; }
diff -ur slackware64-current.2/source/l/Imath/Imath.SlackBuild slackware64-current.3/source/l/Imath/Imath.SlackBuild
--- slackware64-current.2/source/l/Imath/Imath.SlackBuild	2025-08-27 21:09:46.882269320 +0200
+++ slackware64-current.3/source/l/Imath/Imath.SlackBuild	2025-08-29 20:44:50.207554691 +0200
@@ -72,6 +72,11 @@
 rm -rf $PKGNAM-$VERSION
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z* || exit 1
 cd $PKGNAM-$VERSION || exit 1
+
+# On Alpha, cmake is not able to detect numpy include dir.
+# Make a symbolic link into sources:
+ln -s  /usr/lib$LIBDIRSUFFIX/python3*/site-packages/numpy/_core/include/numpy src/Imath/numpy
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/aalib/aalib.SlackBuild slackware64-current.3/source/l/aalib/aalib.SlackBuild
--- slackware64-current.2/source/l/aalib/aalib.SlackBuild	2021-02-13 06:31:56.092945400 +0100
+++ slackware64-current.3/source/l/aalib/aalib.SlackBuild	2021-09-18 13:42:54.276965781 +0200
@@ -71,7 +71,8 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.gz || exit 1
 cd ${PKGNAM}-${SRCVER} || exit 1
 #cp /usr/share/libtool/config.{guess,sub} .             # libtool-1.x
-cp /usr/share/libtool/config/config.{guess,sub} .       # libtool-2.x
+#cp /usr/share/libtool/config/config.{guess,sub} .       # libtool-2.x
+\cp /usr/share/libtool/build-aux/config.* . 
 sed -i -e "s# -lslang# -lslang1#" configure
 
 zcat $CWD/aalib-aclocal.patch.gz | patch -p1 --verbose || exit 1
diff -ur slackware64-current.2/source/l/abseil-cpp/abseil-cpp.SlackBuild slackware64-current.3/source/l/abseil-cpp/abseil-cpp.SlackBuild
--- slackware64-current.2/source/l/abseil-cpp/abseil-cpp.SlackBuild	2024-04-06 20:29:52.442582216 +0200
+++ slackware64-current.3/source/l/abseil-cpp/abseil-cpp.SlackBuild	2024-05-30 11:34:14.793585046 +0200
@@ -78,6 +78,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Adding or1k in the list of architectures supporting mmap2 and program counter context:
+zcat $CWD/adding_or1k_support.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -94,6 +94,7 @@
     -DMAN_INSTALL_DIR=/usr/man \
     -DCMAKE_CXX_STANDARD=17 \
     -DBUILD_SHARED_LIBS=ON \
+    $CMAKE_EXTRA \
     .. || exit 1
   make $NUMJOBS || make || exit 1
   make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/aom/aom.SlackBuild slackware64-current.3/source/l/aom/aom.SlackBuild
--- slackware64-current.2/source/l/aom/aom.SlackBuild	2024-05-10 13:31:52.270717603 +0200
+++ slackware64-current.3/source/l/aom/aom.SlackBuild	2025-02-18 16:15:48.244901196 +0100
@@ -80,6 +80,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# AOM incorrectly redefines neon gcc's builtins: comment out them:
+zcat $CWD/arm_no_neon_redefine.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -99,6 +99,7 @@
     -DENABLE_DOCS=0 \
     -DBUILD_SHARED_LIBS=1 \
     -DENABLE_TESTS=0 \
+    $CMAKE_EXTRA \
     .. || exit 1
   make $NUMJOBS || make || exit 1
   make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/apr/apr.SlackBuild slackware64-current.3/source/l/apr/apr.SlackBuild
--- slackware64-current.2/source/l/apr/apr.SlackBuild	2023-02-01 22:28:25.912750044 +0100
+++ slackware64-current.3/source/l/apr/apr.SlackBuild	2023-07-27 14:25:42.455046559 +0200
@@ -78,7 +82,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Fix incorrect mutex definitions for or1k:
+zcat $CWD/proc_mutex.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/l/argon2/argon2.SlackBuild slackware64-current.3/source/l/argon2/argon2.SlackBuild
--- slackware64-current.2/source/l/argon2/argon2.SlackBuild	2024-08-22 14:34:35.632037061 +0200
+++ slackware64-current.3/source/l/argon2/argon2.SlackBuild	2024-08-23 03:21:19.518174809 +0200
@@ -91,8 +91,8 @@
 sed -i "s/LIBRARY_REL ?= lib.*/LIBRARY_REL = lib${LIBDIRSUFFIX}/g" Makefile
 sed -i "s/CFLAGS += -march=\$(OPTTARGET)/CFLAGS += ${SLKCFLAGS}/g" Makefile
 
-make || exit 1
-make install DESTDIR=$PKG || exit 1
+OPTTARGET=$ARCH make || exit 1
+OPTTARGET=$ARCH make install DESTDIR=$PKG || exit 1
 
 # Ditch static library:
 rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libargon2.a
diff -ur slackware64-current.2/source/l/boost/boost.SlackBuild slackware64-current.3/source/l/boost/boost.SlackBuild
--- slackware64-current.2/source/l/boost/boost.SlackBuild	2024-11-04 02:11:21.013796446 +0100
+++ slackware64-current.3/source/l/boost/boost.SlackBuild	2024-12-06 12:22:02.603699317 +0100
@@ -78,6 +78,26 @@
 tar xf $CWD/boost_$VERSION.tar.?z || exit 1
 cd boost_$VERSION || exit 1
 
+# From 1.77 BOOST_MATH_NO_ATOMIC_INT was removed from bernoulli code.
+# Reintegrate it:
+zcat $CWD/reintegrate_BOOST_MATH_NO_ATOMIC_INT.diff.gz | patch -p1 --verbose || exit 1
+# Change -mcpu=v7 to -mcpu=leon3 for sparc to support atomic operation (otherwise
+# "Boost.Atomic unsupported target platform: native atomic operations not implemented for bytes):
+zcat $CWD/sparc_cpu_leon3.diff.gz | patch -p1 --verbose || exit 1
+# PowerPC has custom long-double implementation, disable it on "from_chars" function:
+zcat $CWD/disable_from_chars_long-double_powerpc.diff.gz | patch -p1 --verbose || exit 1
+# With newer compiler duplicate case are errors, avoid in architectures that supports both
+# SIGPWR and SIGINFO (synonyms):
+zcat $CWD/sigpwr_siginfo_duplicate_case.diff.gz | patch -p1 --verbose || exit 1
+
+# Avoid error " On this platform memory leaks are possible if capturing stacktrace from exceptions 
+# is enabled and exceptions are thrown concurrently and libc++ runtime is used. 
+# Define `BOOST_STACKTRACE_LIBCXX_RUNTIME_MAY_CAUSE_MEMORY_LEAK` to suppress this error if the 
+# library would not be used with libc++ runtime (for example, it would be only used with GCC runtime).
+# Otherwise, disable the boost_stacktrace_from_exception library build (for example by 
+# `./b2 boost.stacktrace.from_exception=off` option).
+SLKCFLAGS="$SLKCFLAGS -DBOOST_STACKTRACE_LIBCXX_RUNTIME_MAY_CAUSE_MEMORY_LEAK"
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -143,6 +163,20 @@
 cp -a LICENSE* index.html $PKG/usr/doc/boost-$PKG_VERSION
 find $PKG/usr/doc -type f -exec chmod 0644 {} \+
 
+# hppa, or1k, and sh4: from boost 1.86 address-model no more detected.
+# Fix cmake files post installation:
+if [ "$ARCH" = "hppa" -o "$ARCH" = "or1k"  -o "$ARCH" = "sh4" ]
+then
+  if [ `cat  $PKG/usr/lib/cmake/boost*/lib* | grep -c 'CMAKE_SIZEOF_VOID_P EQUAL 4'` -gt 0 ]
+  then
+    sed -i 's/CMAKE_SIZEOF_VOID_P EQUAL 4/CMAKE_SIZEOF_VOID_P EQUAL 8/' $PKG/usr/lib/cmake/boost*/lib*
+  else
+    echo "WARNING: address-model detection fixed for $ARCH"
+    touch $PKG/usr/doc/boost-$PKG_VERSION/address-model-fixed
+    sleep 120
+  fi
+fi
+
 mkdir -p $PKG/install
 cat $CWD/slack-desc > $PKG/install/slack-desc
 
diff -ur slackware64-current.2/source/l/chmlib/chmlib.SlackBuild slackware64-current.3/source/l/chmlib/chmlib.SlackBuild
--- slackware64-current.2/source/l/chmlib/chmlib.SlackBuild	2021-02-13 06:31:56.568945374 +0100
+++ slackware64-current.3/source/l/chmlib/chmlib.SlackBuild	2021-09-18 13:42:54.346969315 +0200
@@ -70,6 +70,13 @@
 rm -rf chmlib-$VERSION
 tar xvf $CWD/chmlib-$VERSION.tar.?z* || exit 1
 cd chmlib-$VERSION || exit 1 || exit 1
+
+# These patches are still needed for arm:
+for i in src_chm_lib.c.diff.gz src_extract_chmLib.c.diff.gz
+do
+  zcat $CWD/$i | patch -p1
+done
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/cryfs/cryfs.SlackBuild slackware64-current.3/source/l/cryfs/cryfs.SlackBuild
--- slackware64-current.2/source/l/cryfs/cryfs.SlackBuild	2021-02-13 06:31:56.635945370 +0100
+++ slackware64-current.3/source/l/cryfs/cryfs.SlackBuild	2021-09-18 13:42:54.396971838 +0200
@@ -79,6 +79,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix building for bigendian or1k
+sed -i -e "s/defined(__ARMEB__)/defined(__ARMEB__) || defined(__or1k__)/" vendor/cryptopp/vendor_cryptopp/config.h
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -89,6 +89,12 @@
 # Oddly, cryfs expects a static boost, so we'll need to hit it with the LART:
 export LDFLAGS="$SLKLDFLAGS -lboost_thread -lboost_program_options -lboost_filesystem -lboost_chrono -lcryptopp -lfuse"
 
+case "$ARCH" in
+  arm|mips|mipsel|ppc|or1k|sh4)
+    export LDFLAGS="$LDFLAGS -latomic"
+    ;;
+esac
+
 # gcc11 fixes:
 zcat $CWD/27587ea1acec5f939a31217f1c43953378f18821.patch.gz | patch -p1 --verbose || exit 1
 
